* -------------------------------
* 	LPS Example
*
* 	Routine 4
*
*	Language: MC68K-ASM1
*	Style: plain MC68000
* 	Version: LPS20-L20-m68k
* -------------------------------

* Lecture L20 Plain MC68000 Solution

*  Questo esempio mostra la traduzione in ASM di un programma C
;	contenente funzioni non-foglia

* Questo esempio e' realizzato per l'assembler ASM-One V1.48

* Variabili
; il tipo int viene memorizzato con word
	org	$4000

; la word seguente contiene il valore che la versione Plain C
; legge da standard input
t:	dc.w	10

; le due word seguenti, al termine del programma contengono i
; valori che la versione Plain C stampa su standard output
a:	dc.w	0
b:	dc.w	0

* Programma
	org	$2000

inizio_codice:

* Routine main
main:
	* input
	; la lettura mediante scanf della versione Plain C
	; viene simulata dalla lettura della word a indirizzo t
	move.w	t,a0
	
	* uso dei registri (routine main, fase di calcolo)
	;	a0 - variabile t
	;	a1 - variabile a
	;	d2 - variabile b

	; 	a = t + 20;
	move.w	a0,a1
	add.w	#20,a1

	; b = 2 * t;
	move.w	a0,d2
	muls	#2,d2

	; a = f( 10, a, t, b );
	move.w	#10,d4
	move.w	a1,d5
	move.w	a0,d6
	move.w	d2,d7
	bsr	f
	; d3 ha il risultato di f
	move.w	d3,a1

	; b = f( t, a, 24, b );
	move.w	a0,d4
	move.w	a1,d5
	move.w	#24,d6
	move.w	d2,d7
	bsr	f
	move.w	d3,d2

	
	* output
	; la scrittura mediante printf della versione Plain C
	; viene simulata dalla scrittura delle word a indirizzo a e b
	move.w	a1,a
	move.w	d2,b

fine_main:

	* fine programma
	bra	fine_codice

* Routine media
; Input
;	d0 (word) - parametro a
;	d1 (word) - parametro b
; Output
;	d0 (word) - risultato
; Registri modificati
;	d0
media:
	add.w	d1,d0
	asr.w	#1,d0
	rts

* Routine f
; Input
;	d4 - parametro x
;	d5 - parametro y
;	d6 - parametro z
;	d7 - parametro w
; Output
;	d3 - risultato
; Registri modificati
;	d3 - variabile t e risultato
f:
	move.w	d4,d0
	move.w	d5,d1
	bsr	media
	move.w	d0,d3

	cmp.w	d6,d3
	bge	f_if_end	
	move.w	d6,d0
	move.w	d7,d1
	bsr	media
	add.w	d0,d3

f_if_end:
	rts

fine_codice:

	end

* Original Plain C Code

#include <stdio.h>

int media( int a, int b ) {
	return ( a + b ) / 2;
}

int f( int x, int y, int z, int w ) {
	int t = media( x, y );
	if ( t < z )
		t += media( z, w );
	return t;
}

int main( void ) {

	int a, b, t;

	/* input */
	scanf( "%d", &t );

	a = t + 20;
	b = 2 * t;
	a = f( 10, a, t, b );
	b = f( t, a, 24, b );


	/* output */
	printf( "%d %d\n", a, b );

	return 0;
}

/*
	Test Cases

	Test 1
	input: 10
	output: 20 37

	Test 2
	input: 15
	output: 22 45

	Test 3
	input: -20
	output: 5 -15

	Test 4
	input: -10
	output: 10 2
*/
